-----------------------------------------------------
-- Tidy Plates ArenaLive
-----------------------------------------------------

-----------------------------------------------------
-- Theme Definition
-----------------------------------------------------
local Theme = {}
local ThemeName = "ArenaLive"
local CopyTable = TidyPlatesUtility.copyTable
local EmptyTexture = "Interface\\Addons\\TidyPlatesHub\\shared\\Empty"
local path = "Interface\\Addons\\TidyPlates_ArenaLive\\" 
local font = "Interface\\Addons\\TidyPlatesHub\\shared\\AccidentalPresidency.ttf"

local nameplateOffsetV = -12;
local castbarOffsetV = nameplateOffsetV;

-- Non-Latin Font Bypass
local NonLatinLocales = { ["ruRU"] = true, ["koKR"] = true, ["zhCN"] = true, ["zhTW"] = true, }
if NonLatinLocales[GetLocale()] == true then font = NAMEPLATE_FONT end

local StyleDefault = {}


StyleDefault.frame = {
	width = 140,
	height = 35,
	x = 0,
	y = 0,	-- (-12) To put the bar near the middle
	anchor = "CENTER",
}

StyleDefault.healthborder = {
	texture = path.."RegularBorder",
	width = 128,
	height = 64,
	x = 0,
	y = nameplateOffsetV,
	anchor = "CENTER",
}

StyleDefault.healthbar = {
	texture = "Interface\\TargetingFrame\\UI-StatusBar",
	backdrop = EmptyTexture,
	height = 12,
	width = 100,
	x = 0,
	y = 3,
	anchor = "CENTER",
	orientation = "HORIZONTAL",
}

StyleDefault.target = {
	show = false,
}

StyleDefault.highlight = {
	texture = path.."RegularBorder",
}

StyleDefault.threatborder = {
	texture = path.."RegularThreat",
	width = 128,
	height = 64,
	x = 0,
	y = nameplateOffsetV,
	anchor = "CENTER",
}

StyleDefault.castbar = {
	texture = "Interface\\TargetingFrame\\UI-StatusBar",
	backdrop = EmptyTexture,
	height = 12,
	width = 86,
	x = 7,
	y = 1+castbarOffsetV,
	anchor = "CENTER",
	orientation = "HORIZONTAL",
}

StyleDefault.castborder = {
	texture = path.."RegularBorderCastbar",
	width = 128,
	height = 64,
	x = 0,
	y = -2+nameplateOffsetV+castbarOffsetV,
	anchor = "CENTER",
}

StyleDefault.castnostop = {
	texture = path.."RegularBorder",
	width = 128,
	height = 64,
	x = 0,
	y = 0+nameplateOffsetV+castbarOffsetV,
	anchor = "CENTER",
}

StyleDefault.name = {
	typeface = font,
	size = 12,
	height = 12,
	width = 180,
	x = 20,
	y = nameplateOffsetV + 17,
	align = "LEFT",
	anchor = "TOPLEFT",
	vertical = "BOTTOM",
	shadow = true,
	outline = "NORMAL",
	flags = "NONE",
}

StyleDefault.level = {
	typeface = font,
	size = 10,
	width = 93,
	height = 10,
	x = -2,
	y = nameplateOffsetV + 12,
	align = "RIGHT",
	anchor = "TOP",
	vertical = "BOTTOM",
	shadow = false,
	flags = "NONE",
	show = false,
}

StyleDefault.customtext = {
	typeface = font,
	size = 9,
	width = 93,
	height = 10,
	x = 0,
	y = nameplateOffsetV + 16,
	align = "RIGHT",
	anchor = "CENTER",
	vertical = "BOTTOM",
	shadow = true,
	flags = "NONE",
	show = true,
}

StyleDefault.spelltext = {
	typeface = font,
	size = 10,
	height = 10,
	width = 180,
	x = 0,
	y = -11 + castbarOffsetV,
	align = "CENTER",
	anchor = "TOP",
	vertical = "BOTTOM",
	shadow = true,
	flags = "NONE",
	show = true,
}

StyleDefault.spellicon = {
	width = 14,
	height = 14,
	x = -43,
	y = castbarOffsetV,
	anchor = "CENTER",
}

StyleDefault.eliteicon = {
	texture = path.."EliteBorder",
	width = 128,
	height = 64,
	x = 0,
	y = nameplateOffsetV,
	anchor = "CENTER",
	show = true,
}

StyleDefault.raidicon = {
	width = 25,
	height = 25,
	x = -60,
	y = nameplateOffsetV + 25,
	anchor = "CENTER",
}

StyleDefault.skullicon = {
	width = 8,
	height = 8,
	x = 32,
	y = 7,
	anchor = "TOP",
}

StyleDefault.threatcolor = {
	LOW = {r = 0.6, g = 1, b = 0, a = 0,},
	MEDIUM = {r = 0.6, g = 1, b = 0, a = 1,},
	HIGH = {r = 1, g = 0, b = 0, a= 1,},  }

-- No-Bar Style		(6.2)
local StyleTextOnly = CopyTable(StyleDefault)
StyleTextOnly.threatborder.texture = EmptyTexture
StyleTextOnly.healthborder.texture = EmptyTexture
StyleTextOnly.healthborder.y = nameplateOffsetV - 7
StyleTextOnly.healthbar.texture = EmptyTexture
StyleTextOnly.healthbar.backdrop = EmptyTexture
StyleTextOnly.eliteicon.texture = EmptyTexture
--StyleTextOnly.name.flags = "OUTLINE"
StyleTextOnly.name.align = "CENTER"
StyleTextOnly.name.anchor = "CENTER"
StyleTextOnly.name.size = 12
StyleTextOnly.name.y = 12
StyleTextOnly.name.x = 0
StyleTextOnly.name.width = 200
StyleTextOnly.customtext.align = "CENTER"
--StyleTextOnly.customtext.flags = "OUTLINE"
StyleTextOnly.customtext.size = 8
StyleTextOnly.customtext.y = 3
StyleTextOnly.customtext.x = 0
StyleTextOnly.level.show = false
StyleTextOnly.skullicon.show = false
StyleTextOnly.eliteicon.show = false
StyleTextOnly.highlight.texture = "Interface\\Addons\\TidyPlatesHub\\shared\\Highlight"
StyleTextOnly.target.texture = "Interface\\Addons\\TidyPlatesHub\\shared\\Target"
StyleTextOnly.target.y = nameplateOffsetV - 8
StyleTextOnly.target.height = 66

local WidgetConfig = {}
WidgetConfig.ClassIcon = { anchor = "TOP" , x = 32 ,y = 7 }
WidgetConfig.TotemIcon = { anchor = "TOP" , x = 32 ,y = 7 }
WidgetConfig.ThreatLineWidget = { anchor =  "LEFT", x = 100 ,y = 0 }
WidgetConfig.ThreatWheelWidget = { anchor =  "LEFT", x = 100 ,y = 0 } -- "CENTER", plate, 30, 18
WidgetConfig.ComboWidget = { anchor = "CENTER" , x = 0 ,y = 24 }
WidgetConfig.RangeWidget = { anchor = "CENTER" , x = 0 ,y = 12 }
WidgetConfig.DebuffWidget = { anchor = "CENTER" , x = 15 ,y = 32 }
if (UnitClassBase("player") == "Druid") or (UnitClassBase("player") == "Rogue") then
	WidgetConfig.DebuffWidgetPlus = { anchor = "CENTER" , x = 15 ,y = 38 }
end

local DamageThemeName = "ArenaLive/|cFFFF4400Damage"
local TankThemeName = "ArenaLive/|cFF3782D1Tank"

Theme["Default"] = StyleDefault
Theme["NameOnly"] = StyleTextOnly			

SLASH_GREYTANK1 = '/greytank'
SlashCmdList['GREYTANK'] = ShowTidyPlatesHubTankPanel

SLASH_GREYDPS1 = '/greydps'
SlashCmdList['GREYDPS'] = ShowTidyPlatesHubDamagePanel





---------------------------------------------
-- Tidy Plates Hub Integration
---------------------------------------------

TidyPlatesThemeList[DamageThemeName] = Theme
local LocalVars = TidyPlatesHubDamageVariables

local ApplyThemeCustomization = TidyPlatesHubFunctions.ApplyThemeCustomization

local function ApplyDamageCustomization()
	ApplyThemeCustomization(Theme)
end

local function OnInitialize(plate)
	TidyPlatesHubFunctions.OnInitializeWidgets(plate, WidgetConfig)
end

local function OnActivateTheme(themeTable)
		if Theme == themeTable then
			LocalVars = TidyPlatesHubFunctions:UseDamageVariables()
			ApplyDamageCustomization()
		end
end

Theme.SetNameColor = TidyPlatesHubFunctions.SetNameColor
Theme.SetScale = TidyPlatesHubFunctions.SetScale
Theme.SetAlpha = TidyPlatesHubFunctions.SetAlpha
Theme.SetHealthbarColor = TidyPlatesHubFunctions.SetHealthbarColor
Theme.SetThreatColor = TidyPlatesHubFunctions.SetThreatColor
Theme.SetCastbarColor = TidyPlatesHubFunctions.SetCastbarColor
Theme.SetCustomText = TidyPlatesHubFunctions.SetCustomText
Theme.OnUpdate = TidyPlatesHubFunctions.OnUpdate
Theme.OnContextUpdate = TidyPlatesHubFunctions.OnContextUpdate
Theme.ShowConfigPanel = ShowTidyPlatesHubDamagePanel
Theme.SetStyle = TidyPlatesHubFunctions.SetStyleBinary
Theme.SetCustomText = TidyPlatesHubFunctions.SetCustomTextBinary
Theme.OnInitialize = OnInitialize		-- Need to provide widget positions
Theme.OnActivateTheme = OnActivateTheme -- called by Tidy Plates Core, Theme Loader
Theme.OnApplyThemeCustomization = ApplyDamageCustomization -- Called By Hub Panel

do
	local TankTheme = CopyTable(Theme)
	TidyPlatesThemeList[TankThemeName] = TankTheme
	
	local function ApplyTankCustomization()
		ApplyThemeCustomization(TankTheme)
	end

	local function OnActivateTheme(themeTable)
		if TankTheme == themeTable then
			LocalVars = TidyPlatesHubFunctions:UseTankVariables()
			ApplyTankCustomization()
		end
	end
	
	TankTheme.OnActivateTheme = OnActivateTheme -- called by Tidy Plates Core, Theme Loader
	TankTheme.OnApplyThemeCustomization = ApplyTankCustomization -- Called By Hub Panel
	TankTheme.ShowConfigPanel = ShowTidyPlatesHubTankPanel
end
